# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from typing import Dict, List, Union, Optional
from datetime import datetime
from typing_extensions import Literal, Annotated, TypeAlias

from ..._utils import PropertyInfo
from ..._models import BaseModel
from .schema_generation_base import SchemaGenerationBase
from .artifact_schema_generation import ArtifactSchemaGeneration
from ..shared.chunk_extra_info_schema import ChunkExtraInfoSchema
from ..shared.string_extra_info_schema import StringExtraInfoSchema

__all__ = [
    "TestCase",
    "GenerationTestCaseVersionResponse",
    "GenerationTestCaseVersionResponseTestCaseData",
    "FlexibleTestCaseVersionResponse",
    "FlexibleTestCaseVersionResponseTestCaseData",
    "FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfFlexibleIoChunk",
    "FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2",
    "FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfFlexibleIoChunk",
    "FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2",
    "FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedExtraInfo",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfFlexibleIoChunk",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfFlexibleIoChunk",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage",
    "FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage",
]

GenerationTestCaseVersionResponseTestCaseData: TypeAlias = Union[ArtifactSchemaGeneration, SchemaGenerationBase]


class GenerationTestCaseVersionResponse(BaseModel):
    id: str
    """The unique identifier of the entity."""

    account_id: str
    """The ID of the account that owns the given entity."""

    autogenerated: bool
    """Boolean to track whether or not the test case is autogenerated"""

    created_at: datetime
    """The date and time when the entity was created in ISO format."""

    created_by_user_id: str
    """The user who originally created the entity."""

    evaluation_dataset_id: str
    """The ID of the associated evaluation dataset."""

    test_case_data: GenerationTestCaseVersionResponseTestCaseData

    archived_at: Optional[datetime] = None
    """The date and time when the entity was archived in ISO format."""

    chat_history: Optional[object] = None
    """Used for tracking previous chat interactions for multi-chat test cases"""

    schema_type: Optional[Literal["GENERATION"]] = None

    test_case_metadata: Optional[object] = None
    """Metadata for the test case"""


class FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfFlexibleIoChunk(BaseModel):
    text: str

    metadata: Optional[object] = None


class FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["user"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["assistant"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["system"]] = None


FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2: TypeAlias = Annotated[
    Union[
        FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage,
        FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage,
        FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage,
    ],
    PropertyInfo(discriminator="role"),
]


class FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfFlexibleIoChunk(
    BaseModel
):
    text: str

    metadata: Optional[object] = None


class FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["user"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["assistant"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["system"]] = None


FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2: TypeAlias = Annotated[
    Union[
        FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage,
        FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage,
        FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage,
    ],
    PropertyInfo(discriminator="role"),
]

FlexibleTestCaseVersionResponseTestCaseDataExpectedExtraInfo: TypeAlias = Annotated[
    Union[ChunkExtraInfoSchema, StringExtraInfoSchema], PropertyInfo(discriminator="schema_type")
]


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfFlexibleIoChunk(BaseModel):
    text: str

    metadata: Optional[object] = None


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["user"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["assistant"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["system"]] = None


FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2: TypeAlias = Annotated[
    Union[
        FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage,
        FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage,
        FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage,
    ],
    PropertyInfo(discriminator="role"),
]


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfFlexibleIoChunk(
    BaseModel
):
    text: str

    metadata: Optional[object] = None


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["user"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["assistant"]] = None


class FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage(
    BaseModel
):
    content: str

    role: Optional[Literal["system"]] = None


FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2: TypeAlias = Annotated[
    Union[
        FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesUserMessage,
        FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesAssistantMessage,
        FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2EgpAPIBackendServerInternalEntitiesSystemMessage,
    ],
    PropertyInfo(discriminator="role"),
]


class FlexibleTestCaseVersionResponseTestCaseData(BaseModel):
    input: Union[
        str,
        float,
        List[FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfFlexibleIoChunk],
        List[FlexibleTestCaseVersionResponseTestCaseDataInputArrayOfChatMessageV2],
        List[object],
        Dict[
            str,
            Union[
                str,
                float,
                List[
                    FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfFlexibleIoChunk
                ],
                List[
                    FlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataInputSomeAdditionalPropertiesItemArrayOfChatMessageV2
                ],
                List[object],
                object,
            ],
        ],
        object,
    ]

    expected_extra_info: Optional[FlexibleTestCaseVersionResponseTestCaseDataExpectedExtraInfo] = None

    expected_output: Union[
        str,
        float,
        List[FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfFlexibleIoChunk],
        List[FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputArrayOfChatMessageV2],
        List[object],
        Dict[
            str,
            Union[
                str,
                float,
                List[
                    FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfFlexibleIoChunk
                ],
                List[
                    FlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesFlexibleTestCaseVersionResponseTestCaseDataExpectedOutputSomeAdditionalPropertiesItemArrayOfChatMessageV2
                ],
                List[object],
                object,
            ],
        ],
        object,
        None,
    ] = None


class FlexibleTestCaseVersionResponse(BaseModel):
    id: str
    """The unique identifier of the entity."""

    account_id: str
    """The ID of the account that owns the given entity."""

    autogenerated: bool
    """Boolean to track whether or not the test case is autogenerated"""

    created_at: datetime
    """The date and time when the entity was created in ISO format."""

    created_by_user_id: str
    """The user who originally created the entity."""

    evaluation_dataset_id: str
    """The ID of the associated evaluation dataset."""

    test_case_data: FlexibleTestCaseVersionResponseTestCaseData

    archived_at: Optional[datetime] = None
    """The date and time when the entity was archived in ISO format."""

    chat_history: Optional[object] = None
    """Used for tracking previous chat interactions for multi-chat test cases"""

    schema_type: Optional[Literal["FLEXIBLE"]] = None

    test_case_metadata: Optional[object] = None
    """Metadata for the test case"""


TestCase: TypeAlias = Annotated[
    Union[GenerationTestCaseVersionResponse, FlexibleTestCaseVersionResponse], PropertyInfo(discriminator="schema_type")
]
